#ifndef OPERATORUNIONMANAGER_H
#define OPERATORUNIONMANAGER_H

#include "../Interfaces/OperatorManagerInterface.h"


/// Class for creation of operators union.
class OperatorUnionManager : public OperatorManagerInterface {

public :
  
  // **************************
  // Design Pattern "Singleton"
  // **************************
  
  static OperatorUnionManager * getInstance ();
  static void destroyInstance ();

  // **********************************
  // Interface OperatorManagerInterface
  // **********************************

  OperatorInterface * createOperator ();

protected :

  // ************************************
  // Protected because of the "Singleton"
  // ************************************
  
  OperatorUnionManager () {}
  virtual ~OperatorUnionManager () {}

};

#endif // OPERATORUNIONMANAGER_H
