// --------------------------------------------------------------------------
//
// Reality
//
// --------------------------------------------------------------------------
//
// Sebastien Dedieu     (dedieu@labri.u-bordeaux.fr)
//
// LaBRI (Laboratoire Bordelais de Recherche en Informatique)
// Universit Bordeaux I - CNRS UMR 5800
// 351, cours de la Libration
// 33405 Talence Cedex
// France
//
// --------------------------------------------------------------------------


/*

  LinearSolver.hpp
  Aout 1999

*/

#ifndef LINEAR_SOLVER
#define LINEAR_SOLVER


/**

  Classe de resolution de systemes d'equations lineaires avec la
  methodes de moindres carres.

  @author Sebastien Dedieu et surtout "Numerical Recipe in C"

*/


class LinearSolver
{
  public:

  /// Lancement du calcul.
  static void solve(int nbEquations, int nbUnknowns,
		    const double *equations,
		    const double *results,
		    double *unknowns);
};


#endif // LINEAR_SOLVER
