
#include "hfpolymesh.h"
/*********Modified by Schmitt 03-05-2001*/
void HFPolyMesh::CreateNormals(){
	/**ATTRIBUTES : IS IT NEEDED? I DO NOT THINK SO... CHECK LATER!!!*/
	
	itsData.initNormal();
	vector<double> norm(3,0.0);
	int count=itsData.getNumV();
	for(int i=0; i<count; i++){
		//Calculate a normal
		CalcNormal(i,&norm);
		//Save Normal
		itsData.setNormal(i, norm);
		}
	itsData.ccwTriangles();
	}

/***FOR ATTRIBUTES : to be more clear and for debuging,
I did not add a parameter to this function (the S array).
It is not needed, because S blelongs to the PolyMesh class.
*/ 
double HFPolyMesh::CalcVal(const double pos[3]){
	itsSendingX[itsXMap]=pos[0];
	itsSendingX[itsYMap]=pos[1];
	itsSendingX[itsZMap]=pos[2];
	/*******ADDED FOR S ATTRIBUTES*/
	//Reset of the array S
	//for(int i=0;i<itsSSize;i++) itsSAttributes[i]=0.0;
	return calc(itsSendingX,itsSAttributes);
	}

/******For Attibutes : During the refinement process
/******vertices where the function value is negative
/******due to the polygonalisation, are replaced 
/******with another close vertices where the function 
/****** value becomes positive. Thus, a new normal is need.
*/

void HFPolyMesh::CalcNormal(int i,vector<double> *norm){

	double val=itsData.getFunctVal(i);
	double pos[3];
		pos[0]=itsSendingX[itsXMap]=itsData.getVertex(i,0);
		pos[1]=itsSendingX[itsYMap]=itsData.getVertex(i,1);
		pos[2]=itsSendingX[itsZMap]=itsData.getVertex(i,2);
		//XPoint
		itsSendingX[itsXMap]+=itsNormDelt[0];
		(*norm)[0]=-((calc(itsSendingX,itsSAttributes)-val)/itsNormDelt[0]);
		//YPoint
		itsSendingX[itsYMap]+=itsNormDelt[1];
		itsSendingX[itsXMap]=pos[0];
		(*norm)[1]=-((calc(itsSendingX,itsSAttributes)-val)/itsNormDelt[1]);
		//ZPoint
		itsSendingX[itsZMap]+=itsNormDelt[2];
		itsSendingX[itsYMap]=pos[1];
		(*norm)[2]=-((calc(itsSendingX,itsSAttributes)-val)/itsNormDelt[2]);
		//Normalize
		double length=sqrt((*norm)[0]*(*norm)[0] + (*norm)[1]*(*norm)[1] + (*norm)[2]*(*norm)[2]);
		if(length==0.0) cout << "Normal Length of Zero Error!\n";
		else{
			(*norm)[0]/=length;
			(*norm)[1]/=length;
			(*norm)[2]/=length;
			}
}
