#ifndef COLORCONFIGURATIONWIDGET_H
#define COLORCONFIGURATIONWIDGET_H

#include "../src/Textures/SimpleColorTexture.h"
#include "AbstractConfigurationWidget.h"

/// The Widget for the settings and the creation of a SimpleColorTexture.
class ColorConfigurationWidget : public AbstractConfigurationWidget {
  
  Q_OBJECT
  
public:

  /// The constructor
  ColorConfigurationWidget (QWidget * parent = NULL);

  /// The destructor
  virtual ~ColorConfigurationWidget () {}

  // ********
  // Services
  // ********

  TextureInterface * createTexture () const;
  QPixmap createPixmap () const;

  /// Conforms the object to SimpleColorTexture
  void conformTo (SimpleColorTexture * tex);

protected : 

  virtual void placeUIElements (QLayout * baseLayout);

private:

  QColor chosenColor; 
  QPushButton * colorChooserButton;

private slots:
  void appearColorDialog ();

};
#endif
